# Ergomentum Rspec Matcher

[![Depfu](https://badges.depfu.com/badges/24f5ce37c343c844f70d9186bbe16850/count.svg)](
https://depfu.com/repos/github/ergomentum/ergomentum_rspec?project_id=17277)
[![Maintainability](https://api.codeclimate.com/v1/badges/47249b4acfb1b02fdd8d/maintainability)](
https://codeclimate.com/repos/5f9734dfabc428018c0022a0/maintainability)
[![Test Coverage](https://api.codeclimate.com/v1/badges/47249b4acfb1b02fdd8d/test_coverage)](
https://codeclimate.com/repos/5f9734dfabc428018c0022a0/test_coverage)
[![CircleCI](https://circleci.com/gh/ergomentum/ergomentum_rspec.svg?style=shield&circle-token=e20239599f07aab2a009ccfd9f12a51b6e163ca7)](
https://circleci.com/gh/ergomentum/ergomentum_rspec)

The missing [rspec matchers](https://relishapp.com/rspec/rspec-expectations/v/3-8/docs/custom-matchers) and helpers not
found somewhere else.

## Array matchers

See specs for examples.

[Credits](https://rcode5.wordpress.com/2013/06/07/custom-rspec-matchers-for-arrays/)

## yield matchers

See specs for examples.

## Performance matchers

Utilize the [allocation_stats](https://github.com/srawlins/allocation_stats) Gem. This allows to assure memory
consumption. It might be useful after fixing memory holes.

See specs for examples.

[Credits](https://www.honeybadger.io/blog/testing-object-allocations/)

## Development

Create a PR to make changes. If your change is intended to release a new gem version increment the gem version in
`lib/ergomentum_rspec/version.rb` ([semantic versioning](https://semver.org/)).

After your PR is merged into `main` the gem is build by GitHub actions and deployed to
[https://github.com/ergomentum/ergomentum_rspec/packages](https://github.com/ergomentum/ergomentum_rspec/packages).

Build locally:

```bash
gem build ergomentum_rspec
```

## Resources

RSpec documentation for [Custom Matchers](
https://relishapp.com/rspec/rspec-expectations/v/3-9/docs/custom-matchers/define-a-custom-matcher).

To inspect Rspec details look into the [built in matcher implementations](
https://github.com/rspec/rspec-expectations/tree/master/lib/rspec/matchers/built_in). As well as into the
[`RSpec::Matchers::Composable`](
https://github.com/rspec/rspec-expectations/blob/master/lib/rspec/matchers/composable.rb) class.

Or have a look into the the [`shoulda-matchers`](https://github.com/thoughtbot/shoulda-matchers) implementation [work](
https://thoughtbot.com/blog/shoulda-matchers).

Blog article about the [different ways to write custom matchers](
https://makandracards.com/makandra/662-write-custom-rspec-matchers).
