# frozen_string_literal: true
require_relative "lib/ergomentum_rspec/version"

Gem::Specification.new do |spec| # rubocop:disable Metrics/BlockLength
  spec.name = "ergomentum_rspec"
  spec.version = ErgomentumRspec::VERSION
  spec.authors = ["Ergomentum"]
  spec.email = ["info@ergomentum.de"]
  spec.summary = "Provides regular used rspec custom matchers"
  spec.description = "Regular used rspec matchers not found somewhere else."
  spec.homepage = "https://www.ergomentum.de/"
  spec.licenses = "Nonstandard"

  spec.files = Dir.glob("{bin,lib}/**/*") + %w[README.md Gemfile ergomentum_rspec.gemspec]
  spec.bindir = "exe"
  spec.executables = spec.files.grep(%r{^exe/}, &:basename)
  spec.require_paths = ["lib"]
  spec.required_ruby_version = ">= 3.0.1"

  spec.add_development_dependency "byebug", "~> 11.1.3"
  spec.add_development_dependency "rake", "~> 13.0.1"
  spec.add_development_dependency "rspec_junit_formatter", "~> 0.4.1"
  spec.add_development_dependency "rubocop", "~> 1.8"
  spec.add_development_dependency "rubocop-performance", "~> 1.9"
  spec.add_development_dependency "rubocop-rake"
  spec.add_development_dependency "simplecov", "~> 0.21.2"
  spec.add_development_dependency "test-prof", "~> 1.0.2"
  spec.add_dependency "activemodel", "~> 6.0"
  spec.add_dependency "activesupport", "~> 6.0"
  spec.add_dependency "allocation_stats", "~> 0.1.5"
  spec.add_dependency "rspec", "~> 3.9"
end
